<?php

class smsGateway {

    public static function deleteSmsInById($user, $password, $smsIdList) {
        $webService = "deleteSmsInByIdList";

        $content = smsGateway::getContentHeader($webService);

        $content .= smsGateway::getTagAsText("user", $user);
        $content .= smsGateway::getTagAsText("password", $password);

        // id list
        $content .= "<idList>\r\n";
        if (is_array($smsIdList)) {
            foreach ($smsIdList as $id) {
                $content .= smsGateway::getTagAsText("int", $id);
            }
        } else {
            $content .= smsGateway::getTagAsText("int", $smsIdList);
        }
        $content .= "</idList>\r\n";
        //
        $content .= smsGateway::getContentEnd($webService);

        $response = smsGateway::sendData($content);

        $ret = smsGateway::parseDeleteSms($response);

        return $ret;
    }

    public static function deleteSmsOutById($user, $password, $smsIdList) {
        $webService = "deleteSmsOutByIdList";

        $content = smsGateway::getContentHeader($webService);

        $content .= smsGateway::getTagAsText("user", $user);
        $content .= smsGateway::getTagAsText("password", $password);

        // id list
        $content .= "<idList>\r\n";
        if (is_array($smsIdList)) {
            foreach ($smsIdList as $id) {
                $content .= smsGateway::getTagAsText("int", $id);
            }
        } else {
            $content .= smsGateway::getTagAsText("int", $smsIdList);
        }
        $content .= "</idList>\r\n";
        //
        $content .= smsGateway::getContentEnd($webService);

        $response = smsGateway::sendData($content);

        $ret = smsGateway::parseDeleteSms($response);

        return $ret;
    }

    public static function getCreditAccount($user, $password, $accountId) {

        $webService = "getCreditAccount";

        $content = smsGateway::getContentHeader($webService);

        $content .= smsGateway::getTagAsText("accountId", $accountId);

        $content .= smsGateway::getTagAsText("user", $user);
        $content .= smsGateway::getTagAsText("password", $password);

        $content .= smsGateway::getContentEnd($webService);

        $response = smsGateway::sendData($content);

        $ret = smsGateway::parseGetCredit($response);

        return $ret;
    }

    public static function getCreditUser($user, $password) {

        $webService = "getCreditUser";

        $content = smsGateway::getContentHeader($webService);

        $content .= smsGateway::getTagAsText("user", $user);
        $content .= smsGateway::getTagAsText("password", $password);

        $content .= smsGateway::getContentEnd($webService);

        $response = smsGateway::sendData($content);

        $ret = smsGateway::parseGetCredit($response);

        return $ret;
    }

    public static function getModemsByAccount($user, $password, $accountId) {
        $webService = "getModemsByAccount";

        $content = smsGateway::getContentHeader($webService);

        $content .= smsGateway::getTagAsText("accountId", $accountId);

        $content .= smsGateway::getTagAsText("user", $user);
        $content .= smsGateway::getTagAsText("password", $password);

        $content .= smsGateway::getContentEnd($webService);

        $response = smsGateway::sendData($content);

        $ret = smsGateway::parseGetModemsByAccount($response);

        return $ret;
    }

    public static function getSMSLength($coding, $message, $wap="false", $wlink=null, $wmessage=null, $mode=null, $href=null, $type=null, $validityTime=null, $releaseTime=null) {
        $webService = "getSMSLength";

        $content = smsGateway::getContentHeader($webService);

        $content .= smsGateway::getTagAsText("coding", $coding);
        if ($wap == "true") {
            $content .= smsGateway::getTagAsText("wap", $wap);
            $content .= smsGateway::getTagAsText("wlink", $wlink);
            $content .= smsGateway::getTagAsText("wmessage", $wmessage);
            $content .= smsGateway::getTagAsText("mode", $mode);
            $content .= smsGateway::getTagAsText("href", $href);
            $content .= smsGateway::getTagAsText("type", $type);
            $content .= smsGateway::getTagAsText("validityTime", $validityTime);
            $content .= smsGateway::getTagAsText("releaseTime", $releaseTime);
        } else {
            $content .= smsGateway::getTagAsText("message", $message);
            $content .= smsGateway::getTagAsText("wap", $wap);
        }

        $content .= smsGateway::getContentEnd($webService);

        $response = smsGateway::sendData($content);

        $ret = smsGateway::parseGetSMSLength($response);

        return $ret;
    }

    public static function getSmsInByDedicatedAccount($user, $password) {
        $webService = "getSmsInByDedicatedAccount";

        $content = smsGateway::getContentHeader($webService);

        $content .= smsGateway::getTagAsText("user", $user);
        $content .= smsGateway::getTagAsText("password", $password);

        $content .= smsGateway::getContentEnd($webService);

        $response = smsGateway::sendData($content);

        $ret = smsGateway::parseGetSmsIn($response);

        return $ret;
    }

    public static function getSmsInByNonDedicatedAccount($user, $password) {
        $webService = "getSmsInByNonDedicatedAccount";

        $content = smsGateway::getContentHeader($webService);

        $content .= smsGateway::getTagAsText("user", $user);
        $content .= smsGateway::getTagAsText("password", $password);

        $content .= smsGateway::getContentEnd($webService);

        $response = smsGateway::sendData($content);

        $ret = smsGateway::parseGetSmsIn($response);

        return $ret;
    }

    public static function getSmsInByUser($user, $password) {
        $webService = "getSmsInByUser";

        $content = smsGateway::getContentHeader($webService);

        $content .= smsGateway::getTagAsText("user", $user);
        $content .= smsGateway::getTagAsText("password", $password);

        $content .= smsGateway::getContentEnd($webService);

        $response = smsGateway::sendData($content);

        $ret = smsGateway::parseGetSmsIn($response);

        return $ret;
    }

    public static function getSmsOutByAccount($user, $password, $listDeleted="false") {
        $webService = "getSmsOutByAccount";

        if ($listDeleted != "true") {
            $listDeleted = "false";
        }

        $content = smsGateway::getContentHeader($webService);

        $content .= smsGateway::getTagAsText("user", $user);
        $content .= smsGateway::getTagAsText("password", $password);
        $content .= smsGateway::getTagAsText("listDeleted", $listDeleted);

        $content .= smsGateway::getContentEnd($webService);

        $response = smsGateway::sendData($content);

        $ret = smsGateway::parseGetSmsOut($response);

        return $ret;
    }

    public static function getSmsOutById($user, $password, $smsId) {
        $webService = "getSmsOutById";

        $content = smsGateway::getContentHeader($webService);

        $content .= smsGateway::getTagAsText("user", $user);
        $content .= smsGateway::getTagAsText("password", $password);
        $content .= smsGateway::getTagAsText("sms_id", $smsId);

        $content .= smsGateway::getContentEnd($webService);

        $response = smsGateway::sendData($content);

        $ret = smsGateway::parseGetSmsOutId($response);

        return $ret;
    }

    public static function getSmsOutByUser($user, $password, $listDeleted="false") {
        $webService = "getSmsOutByUser";

        if ($listDeleted != "true") {
            $listDeleted = "false";
        }

        $content = smsGateway::getContentHeader($webService);

        $content .= smsGateway::getTagAsText("user", $user);
        $content .= smsGateway::getTagAsText("password", $password);
        $content .= smsGateway::getTagAsText("listDeleted", $listDeleted);

        $content .= smsGateway::getContentEnd($webService);

        $response = smsGateway::sendData($content);

        $ret = smsGateway::parseGetSmsOut($response);

        return $ret;
    }

    public static function insertSmsOutNormal($user, $password, $text, $recipientList, $bit="7", $wantedSender=null) {
        $webService = "insertSmsOutNormal";

        $content = smsGateway::getContentHeader($webService);

        $content .= smsGateway::getTagAsText("text", $text);
        $content .= smsGateway::getTagAsText("bit", $bit);

        $content .= "<recipientList>\r\n";
        if (is_array($recipientList)) {
            foreach ($recipientList as $rec) {
                $content .= smsGateway::getTagAsText("string", $rec);
            }
        } else {
            $content .= smsGateway::getTagAsText("string", $recipientList);
        }
        $content .= "</recipientList>\r\n";

        if ($wantedSender == null) {
            $content .= "<wantedSenderPhones />\r\n";
        } else {

            $content .= "<wantedSenderPhones>\r\n";
            if (is_array($wantedSender)) {
                foreach ($wantedSender as $want) {
                    $content .= smsGateway::getTagAsText("string", $want);
                }
            } else {
                $content .= smsGateway::getTagAsText("string", $wantedSender);
            }
            $content .= "</wantedSenderPhones>\r\n";
        }


        $content .= smsGateway::getTagAsText("user", $user);
        $content .= smsGateway::getTagAsText("password", $password);

        $content .= smsGateway::getContentEnd($webService);

        $response = smsGateway::sendData($content);

        $ret = smsGateway::parseInsertSms($response);

        return $ret;
    }

    private static function sendData($content) {
        $url = parse_url("http://govcenter.hu/smsgateway/service1.asmx");

        $host = $url['host'];
        $path = $url['path'];

    	$content2 = $content;
        $content = utf8_encode($content);

        //iconv("ISO-8859-2", "UTF-8//TRANSLIT",$content);

        $fp = fsockopen($host, 80);

        fputs($fp, "POST $path HTTP/1.1\r\n");
        fputs($fp, "Host: $host\r\n");
        fputs($fp, "Content-type: text/xml; charset=utf-8\r\n");
        fputs($fp, "Content-length: " . strlen($content) . "\r\n");
        fputs($fp, "Connection: close\r\n\r\n");
        fputs($fp, $content);

        $result = '';
        while (!feof($fp)) {
            // receive the results of the request
            $result .= fgets($fp, 128);
        }
        fclose($fp);

        $result = explode("\r\n\r\n", $result, 2);

        $header = isset($result[0]) ? $result[0] : '';
        $content = isset($result[1]) ? $result[1] : '';
        //$content = utf8_decode($content);
        $doc = new DOMDocument();
        $doc->loadXML($content);
        $doc->normalize();
        return $doc;
    }

    private static function parseDeleteSms($response) {
        $ret['hasError'] = smsGateway::getTagValue('hasError', $response);
        $ret['hasError'] = $ret['hasError'] == "true";
        if ($ret['hasError']) {
            $ret['errorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('errorString', $response));
            $ret['userErrorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('userErrorString', $response));
        }
        return $ret;
    }

    private static function parseGetCredit($response) {
        $ret['hasError'] = smsGateway::getTagValue('hasError', $response);
        $ret['hasError'] = $ret['hasError'] == "true";
        if ($ret['hasError']) {
            $ret['errorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('errorString', $response));
            $ret['userErrorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('userErrorString', $response));
        } else {
            $ret['returnCredit'] = (int) smsGateway::getTagValue('returnValue', $response);
        }

        return $ret;
    }

    private static function parseGetModemsByAccount($response) {
        $ret['hasError'] = smsGateway::getTagValue('hasError', $response);
        $ret['hasError'] = $ret['hasError'] == "true";
        if ($ret['hasError']) {
            $ret['errorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('errorString', $response));
            $ret['userErrorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('userErrorString', $response));
        } else {
            $modems;
            $nodelist = $response->documentElement->firstChild->getElementsByTagName('string');
            foreach ($nodelist as $node) {
                $modems[] = $node->nodeValue;
            }

            $ret['returnModems'] = $modems;
        }

        return $ret;
    }

    private static function parseGetSMSLength($response) {
        $ret['hasError'] = smsGateway::getTagValue('hasError', $response);
        $ret['hasError'] = $ret['hasError'] == "true";
        if ($ret['hasError']) {
            $ret['errorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('errorString', $response));
            $ret['userErrorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('userErrorString', $response));
        } else {
            $ret['returnSmsLength'] = (int) smsGateway::getTagValue('returnValue', $response);
        }

        return $ret;
    }

    private static function parseGetSmsIn($response) {
        $ret['hasError'] = smsGateway::getTagValue('hasError', $response);
        $ret['hasError'] = $ret['hasError'] == "true";
        if ($ret['hasError']) {
            $ret['errorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('errorString', $response));
            $ret['userErrorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('userErrorString', $response));
        } else {
            $SmsIn;
            $nodelist = $response->documentElement->firstChild->getElementsByTagName('SMSIn');
            foreach ($nodelist as $node) {
                $sms['id'] = (int) smsGateway::getTagValueNode("id", $node);
                $sms['text'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("text", $node));
                $sms['sender'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("sender_phone_number", $node));
                $sms['delivery_time'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("delivery_time", $node));
                $sms['calculated_recipient_user'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("calculated_recipient_user", $node));
                $sms['calculated_recipient_account'] = (int) smsGateway::getTagValueNode("calculated_recipient_account", $node);
                $SmsIn[] = $sms;
            }

            $ret['returnSmsIn'] = $SmsIn;
        }

        return $ret;
    }

    private static function parseGetSmsOut($response) {
        $ret['hasError'] = smsGateway::getTagValue('hasError', $response);
        $ret['hasError'] = $ret['hasError'] == "true";
        if ($ret['hasError']) {
            $ret['errorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('errorString', $response));
            $ret['userErrorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('userErrorString', $response));
        } else {
            $SmsOut;
            $nodelist = $response->documentElement->firstChild->getElementsByTagName('SMSOut');
            foreach ($nodelist as $node) {
                //$SmsOut[] = smsGateway::getArray($node);
                $wapList = $node->getElementsByTagName('wapInfo');
                $wapNode = $wapList->item(0);
                $sms['wapInfo'] = null;
                if ($wapNode != null) {

                    $wapInfo['type'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("type", $wapNode));
                    $wapInfo['text'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("text", $wapNode));
                    $wapInfo['link'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("link", $wapNode));
                    $wapInfo['href'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("href", $wapNode));
                    $wapInfo['mode'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("mode", $wapNode));
                    $wapInfo['validityTime'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("validityTime", $node));
                    $wapInfo['releaseTime'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("releaseTime", $node));

                    $sms['wapInfo'] = $wapInfo;
                }
                $modems = null;
                $selectedModemList = $node->getElementsByTagName('selectedModemsToSend');
                foreach ($selectedModemList as $nodeIn) {
                    $nodeOut = $nodeIn->getElementsByTagName('string');
                    foreach ($nodeOut as $nodeString) {
                        $modems[] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", $nodeString->nodeValue);
                    }
                }

                $sms['selectedModemsToSend'] = $modems;

                $sms['concatenated'] = (smsGateway::getTagValueNode("concatenated", $node) == "true");
                $sms['wantedCom'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("wantedCom", $node));
                $sms['recipientProvider'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("recipientProvider", $node));
                $sms['text'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("text", $node));
                $sms['id'] = (int) smsGateway::getTagValueNode("id", $node);
                $sms['tryingDate'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("tryingDate", $node));
                $sms['repeatedSending'] = (smsGateway::getTagValueNode("repeatedSending", $node) == "true");
                $sms['coding'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("coding", $node));
                $sms['flash'] = (smsGateway::getTagValueNode("flash", $node) == "true");
                $sms['ringTone'] = (smsGateway::getTagValueNode("ringTone", $node) == "true");
                $sms['wapPush'] = (smsGateway::getTagValueNode("wapPush", $node) == "true");
                $sms['wantedSendingTime'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("wantedSendingTime", $node));
                $sms['usedSenderPhoneNumber'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("usedSenderPhoneNumber", $node));
                $sms['senderPhoneNumber'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("senderPhoneNumber", $node));
                $sms['recipientPhoneNumber'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("recipientPhoneNumber", $node));
                $sms['part_count'] = (int) smsGateway::getTagValueNode("part_count", $node);
                $sms['account'] = (int) smsGateway::getTagValueNode("account", $node);
                $sms['user'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("user", $node));
                $sms['status'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("status", $node));
                $sms['smsSendedTime'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("smsSendedTime", $node));
                $sms['smsStatusReportReceived'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("smsStatusReportReceived", $node));

                $SmsOut[] = $sms;
            }

            $ret['returnSmsOut'] = $SmsOut;
        }

        return $ret;
    }

    private static function parseGetSmsOutId($response) {
        $ret['hasError'] = smsGateway::getTagValue('hasError', $response);
        $ret['hasError'] = $ret['hasError'] == "true";
        if ($ret['hasError']) {
            $ret['errorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('errorString', $response));
            $ret['userErrorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('userErrorString', $response));
        } else {
            $SmsOut;
            $nodelist = $response->documentElement->firstChild->getElementsByTagName('sms');
            foreach ($nodelist as $node) {
                //$SmsOut[] = smsGateway::getArray($node);
                $wapList = $node->getElementsByTagName('wapInfo');
                $wapNode = $wapList->item(0);
                $sms['wapInfo'] = null;
                if ($wapNode != null) {

                    $wapInfo['type'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("type", $wapNode));
                    $wapInfo['text'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("text", $wapNode));
                    $wapInfo['link'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("link", $wapNode));
                    $wapInfo['href'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("href", $wapNode));
                    $wapInfo['mode'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("mode", $wapNode));
                    $wapInfo['validityTime'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("validityTime", $node));
                    $wapInfo['releaseTime'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("releaseTime", $node));

                    $sms['wapInfo'] = $wapInfo;
                }
                $modems = null;
                $selectedModemList = $node->getElementsByTagName('selectedModemsToSend');
                foreach ($selectedModemList as $nodeIn) {
                    $nodeOut = $nodeIn->getElementsByTagName('string');
                    foreach ($nodeOut as $nodeString) {
                        $modems[] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", $nodeString->nodeValue);
                    }
                }

                $sms['selectedModemsToSend'] = $modems;

                $sms['concatenated'] = (smsGateway::getTagValueNode("concatenated", $node) == "true");
                $sms['wantedCom'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("wantedCom", $node));
                $sms['recipientProvider'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("recipientProvider", $node));
                $sms['text'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("text", $node));
                $sms['id'] = (int) smsGateway::getTagValueNode("id", $node);
                $sms['tryingDate'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("tryingDate", $node));
                $sms['repeatedSending'] = (smsGateway::getTagValueNode("repeatedSending", $node) == "true");
                $sms['coding'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("coding", $node));
                $sms['flash'] = (smsGateway::getTagValueNode("flash", $node) == "true");
                $sms['ringTone'] = (smsGateway::getTagValueNode("ringTone", $node) == "true");
                $sms['wapPush'] = (smsGateway::getTagValueNode("wapPush", $node) == "true");
                $sms['wantedSendingTime'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("wantedSendingTime", $node));
                $sms['usedSenderPhoneNumber'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("usedSenderPhoneNumber", $node));
                $sms['senderPhoneNumber'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("senderPhoneNumber", $node));
                $sms['recipientPhoneNumber'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("recipientPhoneNumber", $node));
                $sms['part_count'] = (int) smsGateway::getTagValueNode("part_count", $node);
                $sms['account'] = (int) smsGateway::getTagValueNode("account", $node);
                $sms['user'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("user", $node));
                $sms['status'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("status", $node));
                $sms['smsSendedTime'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("smsSendedTime", $node));
                $sms['smsStatusReportReceived'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValueNode("smsStatusReportReceived", $node));

                $SmsOut = $sms;
            }

            $ret['returnSmsOut'] = $SmsOut;
        }

        return $ret;
    }

    private static function parseInsertSms($response) {
        $ret['hasError'] = smsGateway::getTagValue('hasError', $response) == "true";

        if ($ret['hasError']) {
            $ret['errorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('errorString', $response));
            $ret['userErrorString'] = iconv("UTF-8", "ISO-8859-2//TRANSLIT", smsGateway::getTagValue('userErrorString', $response));
        } else {
            $ids;
            $nodelist = $response->documentElement->firstChild->getElementsByTagName('int');
            foreach ($nodelist as $node) {
                $ids[] = $node->nodeValue;
            }

            $ret['returnId'] = $ids;
        }

        return $ret;
    }

    private static function getArray($node) {
        $array = false;

        if ($node->hasAttributes()) {
            foreach ($node->attributes as $attr) {
                $array[$attr->nodeName] = $attr->nodeValue;
            }
        }

        if ($node->hasChildNodes()) {
            if ($node->childNodes->length == 1) {
                $array[$node->firstChild->nodeName] = $node->firstChild->nodeValue;
            } else {
                foreach ($node->childNodes as $childNode) {
                    if ($childNode->nodeType != XML_TEXT_NODE) {
                        $array[$childNode->nodeName][] = smsGateway::getArray($childNode);
                    }
                }
            }
        }

        return $array;
    }

    private static function getTagValueNode($tagName, $node) {
        $nodelist = $node->getElementsByTagName($tagName);
        $node = $nodelist->item(0);
        $ret = null;
        if ($node != null)
            $ret = $node->nodeValue;
        return $ret;
    }

    private static function getTagValue($tagName, $doc) {
        $nodelist = $doc->documentElement->firstChild->getElementsByTagName($tagName);
        $node = $nodelist->item(0);
        $ret = null;
        if ($node != null)
            $ret = $node->nodeValue;
        return $ret;
    }

    private static function getContentHeader($webService) {
        return
        '<?xml version="1.0" encoding="utf-8"?>
<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
<soap:Body>
<' . $webService . ' xmlns="http://tempuri.org/">' . "\r\n";
    }

    private static function getContentEnd($webService) {
        return
        '</' . $webService . '>
</soap:Body>
</soap:Envelope>' . "\r\n";
    }

    private static function getTagAsText($tagName, $tagValue) {
        return '<' . $tagName . '>' . $tagValue . '</' . $tagName . ">\r\n";
    }

}

?>